use crate::{database::Database, models::typ::Typ};
use anyhow::{Ok, Result};
use diesel::{QueryDsl, RunQueryDsl, SelectableHelper};

pub struct TypDAO {}

impl TypDAO {
    pub fn get_all_typen(context: &Database) -> Result<Vec<Typ>> {
        use crate::schema::typen::dsl::*;
        let connection = &mut context.pool.get()?;

        let alle_typen = typen.load::<Typ>(connection)?;

        Ok(alle_typen)
    }

    pub fn get_typ_by_id(context: &Database, typ_id: i32) -> Result<Typ> {
        use crate::schema::typen::dsl::*;
        let connection = &mut context.pool.get()?;

        let typ = typen
            .find(typ_id)
            .select(Typ::as_select())
            .first(connection)?;

        Ok(typ)
    }
}
