use diesel::{associations::Identifiable, prelude::Insertable, Queryable, Selectable};
use juniper::{GraphQLInputObject, GraphQLObject};

use crate::schema::typen;

#[derive(GraphQLObject, Queryable, Selectable, Identifiable)]
#[diesel(table_name = typen)]
pub struct Typ {
    pub id: i32,
    pub name: String,
}

#[derive(GraphQLInputObject, Insertable)]
#[diesel(table_name = typen)]
pub struct TypInput {
    pub name: String,
}

#[derive(GraphQLObject)]
pub struct TypResponse {
    pub id: i32,
    pub name: String,
}
