use crate::{database::Database, diesel_dao::typ_dao::TypDAO, models::typ::Typ};
use juniper::{graphql_object, FieldResult};

pub struct Query;

#[graphql_object(context = Database)]
impl Query {
    /// Zeigt alle Gerätetypen an.
    fn typen(#[graphql(context)] context: &Database) -> FieldResult<Vec<Typ>> {
        let alle_typen = TypDAO::get_all_typen(context)?;
        Ok(alle_typen)
    }

    /// Zeigt einen Gerätetypen an
    fn typ(
        #[graphql(context)] context: &Database,
        #[graphql(description = "Die ID des Typs.")] typ_id: i32,
    ) -> FieldResult<Typ> {
        let typ = TypDAO::get_typ_by_id(context, typ_id)?;
        Ok(typ)
    }
}
